<script setup lang="ts">
import { computed, onMounted } from 'vue';
import { nextTick, ref } from 'vue';
import type { VForm } from "vuetify/components";

type Salary = {
  id: number
  name: string
  bankAccount: string
  salary: number
  bonus: number
  netSalary: number
  status: String
}

const salary = ref<Salary[]>([])
const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  }, {
    title: 'Name',
    key: 'name',
    value: 'name'
  }, {
    title: 'Bank Account',
    key: 'bankAccount',
    value: 'bankAccount'
  }, {
    title: 'Salary',
    key: 'salary',
    value: 'salary'
  }, {
    title: 'Bonus',
    key: 'bonus',
    value: 'bonus'
  }, {
    title: 'Net.Salary',
    key: 'netSalary',
    value: 'netSalary'
  }, {
    title: 'Status',
    key: 'status',
    value: 'status'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const initialUser: Salary = {
  id: -1,
  name: '',
  bankAccount: '',
  salary: 0,
  bonus: 0,
  netSalary: 0,
  status: 'Unpaid'
}
const editedUser = ref<Salary>(JSON.parse(JSON.stringify(initialUser)))
let editedIndex = -1
let lastId = 4
function onSubmit() { }

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedUser.value = Object.assign({}, initialUser)
  })
}
function deleteItemConfirm() {
  salary.value.splice(editedIndex, 1)
  closeDelete()
}
function deleteItem(item: Salary) {
  editedIndex = salary.value.indexOf(item)
  editedUser.value = Object.assign({}, item)
  dialogDelete.value = true
  //editedIndex = -1
}
function editItem(item: Salary) {
  editedIndex = salary.value.indexOf(item)
  editedUser.value = Object.assign({}, item)
  dialog.value = true
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedUser.value = Object.assign({}, initialUser)
    editedIndex = -1
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  if (editedIndex > -1) {
    Object.assign(salary.value[editedIndex], editedUser.value)
  } else {
    editedUser.value.id = lastId++
    salary.value.push(editedUser.value)
  }
  editedIndex = -1
  closeDialog()
}
function initialize() {
  salary.value = [
    {
      id: 1,
      name: 'Fey BongBong',
      bankAccount: '376-2-77854-0',
      salary: 50000,
      bonus: 3000,
      netSalary: 53000,
      status: 'Unpaid'

    }, {
      id: 2,
      name: 'Aom YaYaYing',
      bankAccount: '062-8-91223-4',
      salary: 35000,
      bonus: 2000,
      netSalary: 37000,
      status: 'Unpaid'

    }, {
      id: 3,
      name: 'First Sodlor',
      bankAccount: '721-2-09213-3',
      salary: 50000,
      bonus: 2000,
      netSalary: 52000,
      status: 'Unpaid'

    }, {
      id: 4,
      name: 'Cros Santa',
      bankAccount: '001-3-68543-1',
      salary: 50000,
      bonus: 2000,
      netSalary: 52000,
      status: 'Unpaid'

    }, {
      id: 5,
      name: 'Pop Poppy',
      bankAccount: '921-2-43421-3',
      salary: 35000,
      bonus: 4000,
      netSalary: 39000,
      status: 'Unpaid'

    }
  ]
}
onMounted(() => {
  initialize()
})

const paymentSlip = ref('');
const dialogPaymentSlip = ref(false);
let selectedUser = null;

function generatePaymentSlip(item: Salary) {
  if (item.status === "Unpaid") {
    selectedUser = item;
    selectedUser.status = "Paid";
    const usersDetails = [`${selectedUser.name}`];
    const usersSalary = [`${selectedUser.salary}`];
    const usersNetSalary = [`${selectedUser.netSalary}`];
    const usersAcc = [`${selectedUser.bankAccount}`];
    const usersBonus = [`${selectedUser.bonus}`];

    // Format the payment slip
    paymentSlip.value =
      `Date : ${new Date().toLocaleDateString()}                  
Payment Detail
Bank : Krungthai     Bank Account: ${usersAcc.join('\n')}                           

Username : ${usersDetails.join('\n')}  

Salary : ${usersSalary.join('\n')} ฿

Bonus : ${usersBonus.join('\n')} ฿
Net.Salary : ${usersNetSalary.join('\n')} ฿

`;

    // Open the payment slip dialog
    dialogPaymentSlip.value = true;
  }
}

function closePaymentSlipDialog() {
  // Close the payment slip dialog
  dialogPaymentSlip.value = false;
  selectedUser = null;
}

// Save the changes
save();

</script>

<template>
  <div>
        <v-data-table :headers="headers" :items="salary">
        <template v-slot:top>
          
      <v-toolbar flat style="background-color: rgb(97, 63, 45, 0.867);">
        <v-toolbar-title style="color: whitesmoke;">Users</v-toolbar-title>
        <v-divider
          class="mx-4"
          inset
          vertical
        ></v-divider>
        <v-spacer></v-spacer>
        
        
    <v-dialog
      v-model="dialog"
      persistent
      width="1024"
    >
      <template v-slot:activator="{ props }">
        <v-btn
          color="black"
          v-bind="props"
          style="background-color: rgb(216, 201, 201);"
        >
          New Salary
        </v-btn>
      </template>
      <v-card>
        <v-card-title>
          <span class="text-h5">Salary Info</span>
        </v-card-title>
        <v-card-text>
            <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                <v-container>
                    <v-row>
                        <v-col cols="12" sm="12" md="4">
                            <v-text-field
                            v-model="editedUser.name"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="Name"
                              ></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                            <v-text-field
                            v-model="editedUser.bankAccount"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="Bank Account"
                              ></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                            <v-text-field
                            v-model="editedUser.salary"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            clearable
                            label="Salary"
                            placeholder="Enter your Salary"
                              ></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                            <v-text-field
                            v-model="editedUser.bonus"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="Bonus"
                              ></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                            <v-text-field
                            v-model="editedUser.netSalary"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="Net.Salary"
                              ></v-text-field>
                        </v-col>
                    </v-row>
                
                </v-container>

      </v-form>
          <small>*indicates required field</small>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue-darken-1" variant="text" @click="closeDialog">Close</v-btn>
          <v-btn color="blue-darken-1" variant="text" @click="save()">Save</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  
        <!-- Delete Dialog -->
        <v-dialog v-model="dialogDelete" max-width="500px">
          <v-card>
            <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
              <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-toolbar>
        </template>
        <template v-slot:[`item.actions`]="{ item }">
  <v-icon
    size="small"
    class="me-2"
    color="blue-darken-1"
    @click="editItem(item)"
  >
    mdi-pencil
  </v-icon>
  <v-icon
    size="small"
    color="red-accent-4"
    @click="deleteItem(item)"
  >
    mdi-delete
  </v-icon>
  <!-- Payment Slip Dialog -->
  <v-dialog v-model="dialogPaymentSlip" max-width="500px" max-height="1000px">
                    <v-card>
                      <v-card-title class="text-h5 text-center">Payment Successful</v-card-title>
                        <v-card-text>
                            <!-- Display payment slip details here -->
                            <!-- You can format and style the payment slip as needed -->
                            <pre>{{ paymentSlip }}</pre>
                        </v-card-text>

                        <v-card-actions>
                            <v-spacer></v-spacer>
                            <v-btn color="red" variant="text" @click="closePaymentSlipDialog">
                                Close
                            </v-btn>
                        </v-card-actions>
                    </v-card>
                </v-dialog>
                <v-btn
  :color="item.status === 'Unpaid' ? 'green' : 'grey'"
  :disabled="item.status === 'Paid'"
  @click="generatePaymentSlip(item)"
  size="small"
  style="margin: 15%;"
>
  Payment
</v-btn>

</template>
    <template v-slot:no-data>
      <v-btn  
        color="primary"
        @click="initialize"
      >
        Reset
      </v-btn>
    </template>
        </v-data-table>
    </div>
</template>
